Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trabbl.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 2024)
@@ -400,46 +532,96 @@
       !!      called by tra_bbl at the first timestep (nit000)
       !!----------------------------------------------------------------------
-      INTEGER ::   ji, jj      ! dummy loop indices
-      REAL(wp),  DIMENSION(jpi,jpj) :: zmbk  
-
-      NAMELIST/nambbl/ rn_ahtbbl
-      !!----------------------------------------------------------------------
-
-      REWIND ( numnam )              ! Read Namelist nambbl : bottom boundary layer scheme
+      INTEGER ::   ji, jj               ! dummy loop indices
+      INTEGER ::   ii0, ii1, ij0, ij1   ! temporary integer
+      REAL(wp), DIMENSION(jpi,jpj) ::   zmbk   ! 2D workspace 
+
+      NAMELIST/nambbl/ nn_bbl_ldf, nn_bbl_adv, rn_ahtbbl, rn_gambbl
+      !!----------------------------------------------------------------------
+
+      REWIND ( numnam )              !* Read Namelist nambbl : bottom boundary layer scheme
       READ   ( numnam, nambbl )
 
-      IF(lwp) THEN                   ! Parameter control and print
+      IF(lwp) THEN                   !* Parameter control and print
          WRITE(numout,*)
-         WRITE(numout,*) 'tra_bbl_init : '
+         WRITE(numout,*) 'tra_bbl_init : bottom boundary layer initialisation'
          WRITE(numout,*) '~~~~~~~~~~~~'
-         IF( lk_trabbl_dif )   WRITE(numout,*) '               * Diffusive Bottom Boundary Layer'
-         IF( lk_trabbl_adv )   WRITE(numout,*) '               * Advective Bottom Boundary Layer'
          WRITE(numout,*) '       Namelist nambbl : set bbl parameters'
-         WRITE(numout,*) '          bottom boundary layer coef.    rn_ahtbbl = ', rn_ahtbbl
+         WRITE(numout,*) '          diffusive bbl (=1)   or not (=0)    nn_bbl_ldf = ', nn_bbl_ldf
+         WRITE(numout,*) '          advective bbl (=1/2) or not (=0)    nn_bbl_adv = ', nn_bbl_adv
+         WRITE(numout,*) '          diffusive bbl coefficient           rn_ahtbbl  = ', rn_ahtbbl, ' m2/s'
+         WRITE(numout,*) '          advective bbl coefficient           rn_gambbl  = ', rn_gambbl, ' s'
       ENDIF
- 
-      DO jj = 1, jpj
+      
+      IF( nn_bbl_adv == 1 )    WRITE(numout,*) '       * Advective BBL using upper velocity'
+      IF( nn_bbl_adv == 2 )    WRITE(numout,*) '       * Advective BBL using velocity = F( delta rho)'
+
+      IF( nn_eos /= 0 )   CALL ctl_stop ( ' bbl parameterisation requires eos = 0. We stop.' )
+
+
+      !                             !* inverse of surface of T-cells
+      e1e2t_r(:,:) = 1.0 / ( e1t(:,:) * e2t(:,:) )
+      
+      !                             !* vertical index of bottom t-, u- and v-points
+      DO jj = 1, jpj                      ! bottom k-index of T-level
          DO ji = 1, jpi
-            mbkt(ji,jj) = MAX( mbathy(ji,jj) - 1, 1 )   ! vertical index of the bottom ocean T-level
+            mbkt(ji,jj) = MAX( mbathy(ji,jj) - 1, 1 )
          END DO
       END DO
-      DO jj = 1, jpjm1
+      DO jj = 1, jpjm1                    ! bottom k-index of u- (v-) level (shelf and deep)
          DO ji = 1, jpim1
-            mbku(ji,jj) = MAX( MIN( mbathy(ji+1,jj  ), mbathy(ji,jj) ) - 1, 1 )
-            mbkv(ji,jj) = MAX( MIN( mbathy(ji  ,jj+1), mbathy(ji,jj) ) - 1, 1 )
+            mbku  (ji,jj) = MAX( MIN( mbathy(ji+1,jj  ), mbathy(ji,jj) ) - 1, 1 )   ! "shelf"
+            mbkv  (ji,jj) = MAX( MIN( mbathy(ji  ,jj+1), mbathy(ji,jj) ) - 1, 1 )
+            mbku_d(ji,jj) = MAX( MAX( mbathy(ji+1,jj  ), mbathy(ji,jj) ) - 1, 1 )   ! "deep"
+            mbkv_d(ji,jj) = MAX( MAX( mbathy(ji  ,jj+1), mbathy(ji,jj) ) - 1, 1 )
          END DO
       END DO
-
-      zmbk(:,:) = FLOAT( mbku (:,:) )   
-      CALL lbc_lnk(zmbk,'U',1.)
-      mbku(:,:) = MAX( INT( zmbk(:,:) ), 1 ) 
-
-      zmbk(:,:) = FLOAT( mbkv (:,:) )   
-      CALL lbc_lnk(zmbk,'V',1.)
-      mbkv(:,:) = MAX( INT( zmbk(:,:) ), 1 ) 
-
-# if defined key_trabbl_adv
-      w_bbl(:,:,:) = 0.e0          ! initialisation of w_bbl to zero
-# endif
+      zmbk(:,:) = FLOAT( mbku  (:,:) )   ;   CALL lbc_lnk(zmbk,'U',1.)   ;   mbku  (:,:) = MAX( INT( zmbk(:,:) ), 1 )
+      zmbk(:,:) = FLOAT( mbkv  (:,:) )   ;   CALL lbc_lnk(zmbk,'V',1.)   ;   mbkv  (:,:) = MAX( INT( zmbk(:,:) ), 1 )
+      zmbk(:,:) = FLOAT( mbku_d(:,:) )   ;   CALL lbc_lnk(zmbk,'U',1.)   ;   mbku_d(:,:) = MAX( INT( zmbk(:,:) ), 1 )
+      zmbk(:,:) = FLOAT( mbkv_d(:,:) )   ;   CALL lbc_lnk(zmbk,'V',1.)   ;   mbkv_d(:,:) = MAX( INT( zmbk(:,:) ), 1 )
+
+      DO jj = 1, jpj                !* sign of grad(H) at u- and v-points
+         DO ji = 1, jpi
+            mgrhu(ji,jj) = INT(  SIGN( 1.e0, fsdept_0(ji+1,jj,mbkt(ji+1,jj)) - fsdept_0(ji,jj,mbkt(ji,jj)) )  )
+            mgrhv(ji,jj) = INT(  SIGN( 1.e0, fsdept_0(ji,jj+1,mbkt(ji,jj+1)) - fsdept_0(ji,jj,mbkt(ji,jj)) )  )
+         END DO
+      END DO
+
+      DO jj = 1, jpjm1              !* bbl thickness at u- (v-) point 
+         DO ji = 1, jpim1                 ! minimum of top & bottom e3u_0 (e3v_0)
+            e3u_bbl_0(ji,jj) = MIN( fse3u_0(ji,jj,mbkt(ji+1,jj  )), fse3u_0(ji,jj,mbkt(ji,jj)) )  
+            e3v_bbl_0(ji,jj) = MIN( fse3v_0(ji,jj,mbkt(ji  ,jj+1)), fse3v_0(ji,jj,mbkt(ji,jj)) )  
+         END DO 
+      END DO
+      CALL lbc_lnk( e3u_bbl_0, 'U', 1. )   ;   CALL lbc_lnk( e3v_bbl_0, 'V', 1. )      ! lateral boundary conditions
+
+      !                             !* masked diffusive flux coefficients 
+      ahu_bbl_0(:,:) = rn_ahtbbl * e2u(:,:) * e3u_bbl_0(:,:) / e1u(:,:)  * umask(:,:,1)
+      ahv_bbl_0(:,:) = rn_ahtbbl * e1v(:,:) * e3v_bbl_0(:,:) / e2v(:,:)  * vmask(:,:,1)
+
+      IF( cp_cfg == "orca" ) THEN   !* ORCA configuration : regional enhancement of ah_bbl
+         !
+         SELECT CASE ( jp_cfg )
+         CASE ( 2 )                          ! ORCA_R2
+            ij0 = 102   ;   ij1 = 102              ! Gibraltar enhancement of BBL
+            ii0 = 139   ;   ii1 = 140  
+            ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4.e0*ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4.e0*ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            !
+            ij0 =  88   ;   ij1 =  88              ! Red Sea enhancement of BBL
+            ii0 = 161   ;   ii1 = 162
+            ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) = 10.e0*ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) = 10.e0*ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            !
+         CASE ( 4 )                          ! ORCA_R4
+            ij0 =  52   ;   ij1 =  52              ! Gibraltar enhancement of BBL
+            ii0 =  70   ;   ii1 =  71  
+            ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4.e0*ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4.e0*ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+         END SELECT
+         !
+      ENDIF
+      !
+      l_bbl = .TRUE.     !: flag to compute bbl coef and transport
       !
    END SUBROUTINE tra_bbl_init
@@ -449,13 +631,9 @@
    !!   Dummy module :                      No bottom boundary layer scheme
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trabbl_dif = .FALSE.   !: diff bbl flag
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trabbl_adv = .FALSE.   !: adv  bbl flag
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trabbl = .FALSE.   !: bbl flag
 CONTAINS
-   SUBROUTINE tra_bbl_dif( kt )              ! Empty routine
-      WRITE(*,*) 'tra_bbl_dif: You should not have seen this print! error?', kt
-   END SUBROUTINE tra_bbl_dif
-   SUBROUTINE tra_bbl_adv( kt )              ! Empty routine
-      WRITE(*,*) 'tra_bbl_adv: You should not have seen this print! error?', kt
-   END SUBROUTINE tra_bbl_adv
+   SUBROUTINE tra_bbl( kt )              ! Empty routine
+      WRITE(*,*) 'tra_bbl: You should not have seen this print! error?', kt
+   END SUBROUTINE tra_bbl
 #endif
 
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tradmp.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 2024)
@@ -13,4 +13,5 @@
    !!  NEMO      1.0  ! 2002-08  (G. Madec, E. Durand)  free form + modules
    !!            3.2  ! 2009-08  (G. Madec, C. Talandier)  DOCTOR norm for namelist parameter
+   !!            3.3  ! 2010-06  (C. Ethe, G. Madec) merge TRA-TRC 
    !!----------------------------------------------------------------------
 #if   defined key_tradmp   ||   defined key_esopa
@@ -26,6 +27,6 @@
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce         ! ocean space and time domain variables
+   USE trdtra         ! ocean space and time domain variables
    USE zdf_oce         ! ocean vertical physics
    USE phycst          ! Define parameters for the routines
@@ -40,5 +41,8 @@
    PRIVATE
 
-   PUBLIC   tra_dmp    ! routine called by step.F90
+   PUBLIC   tra_dmp      ! routine called by step.F90
+   PUBLIC   tra_dmp_init ! routine called by opa.F90
+   PUBLIC   dtacof       ! routine called by tradmp.F90 and trcdmp.F90
+   PUBLIC   dtacof_zoom  ! routine called by tradmp.F90 and trcdmp.F90
 
 #if ! defined key_agrif
@@ -86,17 +90,14 @@
       !! ** Action  : - (ta,sa)   tracer trends updated with the damping trend
       !!----------------------------------------------------------------------
-      USE oce, ONLY :   ztrdt => ua   ! use ua as 3D workspace   
-      USE oce, ONLY :   ztrds => va   ! use va as 3D workspace   
-      !!
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !!
       INTEGER ::   ji, jj, jk   ! dummy loop indices
-      !!----------------------------------------------------------------------
-
-      IF( kt == nit000 )   CALL tra_dmp_init      ! Initialization
-
-      IF( l_trdtra )   THEN                       ! Save ta and sa trends
-         ztrdt(:,:,:) = ta(:,:,:) 
-         ztrds(:,:,:) = sa(:,:,:) 
+      REAL(wp) ::  zta, zsa
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
+      !!----------------------------------------------------------------------
+
+      IF( l_trdtra )   THEN                    !* Save ta and sa trends
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsa(:,:,:,jp_sal)
       ENDIF
 
@@ -107,6 +108,8 @@
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  ta(ji,jj,jk) = ta(ji,jj,jk) + resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tb(ji,jj,jk) )
-                  sa(ji,jj,jk) = sa(ji,jj,jk) + resto(ji,jj,jk) * ( s_dta(ji,jj,jk) - sb(ji,jj,jk) )
+                  zta = resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_tem) )
+                  zsa = resto(ji,jj,jk) * ( s_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_sal) )
+                  tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta
+                  tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
                END DO
             END DO
@@ -118,6 +121,8 @@
                DO ji = fs_2, fs_jpim1   ! vector opt.
                   IF( avt(ji,jj,jk) <= 5.e-4 ) THEN
-                     ta(ji,jj,jk) = ta(ji,jj,jk) + resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tb(ji,jj,jk) )
-                     sa(ji,jj,jk) = sa(ji,jj,jk) + resto(ji,jj,jk) * ( s_dta(ji,jj,jk) - sb(ji,jj,jk) )
+                     zta = resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_tem) )
+                     zsa = resto(ji,jj,jk) * ( s_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_sal) )
+                     tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta
+                     tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
                   ENDIF
                END DO
@@ -130,6 +135,8 @@
                DO ji = fs_2, fs_jpim1   ! vector opt.
                   IF( fsdept(ji,jj,jk) >= hmlp (ji,jj) ) THEN
-                     ta(ji,jj,jk) = ta(ji,jj,jk) + resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tb(ji,jj,jk) )
-                     sa(ji,jj,jk) = sa(ji,jj,jk) + resto(ji,jj,jk) * ( s_dta(ji,jj,jk) - sb(ji,jj,jk) )
+                     zta = resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_tem) )
+                     zsa = resto(ji,jj,jk) * ( s_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_sal) )
+                     tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta
+                     tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
                   ENDIF
                END DO
@@ -140,11 +147,13 @@
 
       IF( l_trdtra )   THEN       ! trend diagnostic
-         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-         ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
-         CALL trd_mod( ztrdt, ztrds, jptra_trd_dmp, 'TRA', kt )
+         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
+         ztrds(:,:,:) = tsa(:,:,:,jp_sal) - ztrds(:,:,:)
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_dmp, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_dmp, ztrds )
+         DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds )
       ENDIF
       !                           ! Control print
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' dmp  - Ta: ', mask1=tmask,   &
-         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' dmp  - Ta: ', mask1=tmask,   &
+         &                       tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       !
    END SUBROUTINE tra_dmp
@@ -200,6 +209,7 @@
 
       !                          ! Damping coefficients initialization
-      IF( lzoom ) THEN   ;   CALL dtacof_zoom
-      ELSE               ;   CALL dtacof
+      IF( lzoom ) THEN   ;   CALL dtacof_zoom( resto )
+      ELSE               ;   CALL dtacof( nn_hdmp, rn_surf, rn_bot, rn_dep,  &
+                             &            nn_file, 'TRA'  , resto            )
       ENDIF
       !
@@ -207,5 +217,5 @@
 
 
-   SUBROUTINE dtacof_zoom
+   SUBROUTINE dtacof_zoom( presto )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE dtacof_zoom  ***
@@ -220,4 +230,7 @@
       !! ** Action  : - resto, the damping coeff. for T and S
       !!----------------------------------------------------------------------
+      !! * Arguments
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)  ::  presto     !: restoring coeff. (s-1)
+      !
       INTEGER  ::   ji, jj, jk, jn              ! dummy loop indices
       REAL(wp) ::   zlat, zlat0, zlat1, zlat2   ! temporary scalar
@@ -233,12 +246,12 @@
       zfact(:) = zfact(:) / ( 5. * rday )    ! 5 days max restoring time scale
 
-      resto(:,:,:) = 0.e0
+      presto(:,:,:) = 0.e0
 
       ! damping along the forced closed boundary over 6 grid-points
       DO jn = 1, 6
-         IF( lzoom_w )   resto( mi0(jn+jpizoom):mi1(jn+jpizoom), : , : )                    = zfact(jn)   ! west  closed
-         IF( lzoom_s )   resto( : , mj0(jn+jpjzoom):mj1(jn+jpjzoom), : )                    = zfact(jn)   ! south closed 
-         IF( lzoom_e )   resto( mi0(jpiglo+jpizoom-1-jn):mi1(jpiglo+jpizoom-1-jn) , : , : ) = zfact(jn)   ! east  closed 
-         IF( lzoom_n )   resto( : , mj0(jpjglo+jpjzoom-1-jn):mj1(jpjglo+jpjzoom-1-jn) , : ) = zfact(jn)   ! north closed
+         IF( lzoom_w )   presto( mi0(jn+jpizoom):mi1(jn+jpizoom), : , : )                    = zfact(jn)   ! west  closed
+         IF( lzoom_s )   presto( : , mj0(jn+jpjzoom):mj1(jn+jpjzoom), : )                    = zfact(jn)   ! south closed 
+         IF( lzoom_e )   presto( mi0(jpiglo+jpizoom-1-jn):mi1(jpiglo+jpizoom-1-jn) , : , : ) = zfact(jn)   ! east  closed 
+         IF( lzoom_n )   presto( : , mj0(jpjglo+jpjzoom-1-jn):mj1(jpjglo+jpjzoom-1-jn) , : ) = zfact(jn)   ! north closed
       END DO
 
@@ -252,5 +265,5 @@
          !
          !                          ! Initialization : 
-         resto(:,:,:) = 0.e0
+         presto(:,:,:) = 0.e0
          zlat0 = 10.                     ! zlat0 : latitude strip where resto decreases
          zlat1 = 30.                     ! zlat1 : resto = 1 before zlat1
@@ -262,7 +275,7 @@
                   zlat = ABS( gphit(ji,jj) )
                   IF( zlat1 <= zlat .AND. zlat <= zlat2 ) THEN
-                     resto(ji,jj,jk) = 0.5 * ( 1./(5.*rday) ) * ( 1. - cos(rpi*(zlat2-zlat)/zlat0) ) 
+                     presto(ji,jj,jk) = 0.5 * ( 1./(5.*rday) ) * ( 1. - cos(rpi*(zlat2-zlat)/zlat0) ) 
                   ELSEIF( zlat < zlat1 ) THEN
-                     resto(ji,jj,jk) = 1./(5.*rday)
+                     presto(ji,jj,jk) = 1./(5.*rday)
                   ENDIF
                END DO
@@ -272,10 +285,11 @@
       ENDIF
       !                             ! Mask resto array
-      resto(:,:,:) = resto(:,:,:) * tmask(:,:,:)
+      presto(:,:,:) = presto(:,:,:) * tmask(:,:,:)
       !
    END SUBROUTINE dtacof_zoom
 
 
-   SUBROUTINE dtacof
+   SUBROUTINE dtacof( kn_hdmp, pn_surf, pn_bot, pn_dep,  &
+      &               kn_file, cdtype , presto           )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE dtacof  ***
@@ -291,5 +305,13 @@
       USE iom
       USE ioipsl
-      !!
+      !! * Arguments
+      INTEGER                         , INTENT(in   )  ::  kn_hdmp    !: damping option
+      REAL(wp)                        , INTENT(in   )  ::  pn_surf    !: surface time scale (days)
+      REAL(wp)                        , INTENT(in   )  ::  pn_bot     !: bottom time scale (days)
+      REAL(wp)                        , INTENT(in   )  ::  pn_dep     !: depth of transition (meters)
+      INTEGER                         , INTENT(in   )  ::  kn_file    !: save the damping coef on a file or not
+      CHARACTER(len=3)                , INTENT(in   )  ::  cdtype     ! =TRA or TRC (tracer indicator)
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)  ::  presto     !: restoring coeff. (s-1)
+      !
       INTEGER ::   ji, jj, jk                   ! dummy loop indices
       INTEGER ::   ii0, ii1, ij0, ij1           !    -          -
@@ -302,4 +324,5 @@
       REAL(wp), DIMENSION(jpi,jpj)     ::   zmrs
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdct
+      CHARACTER(len=20)                ::   cfile
       !!----------------------------------------------------------------------
 
@@ -313,11 +336,10 @@
 
       ! ... Initialization : 
-      resto(:,:,:) = 0.e0
-
-      !                           !-----------------------------------------!
-      IF( nn_hdmp > 0 ) THEN      !  Damping poleward of 'nn_hdmp' degrees  !
+      presto(:,:,:) = 0.e0
+      !
+      IF( kn_hdmp > 0 ) THEN      !  Damping poleward of 'nn_hdmp' degrees  !
          !                        !-----------------------------------------!
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) '              Damping poleward of ', nn_hdmp,' deg.'
+         IF(lwp) WRITE(numout,*) '              Damping poleward of ', kn_hdmp,' deg.'
          !
          CALL iom_open ( 'dist.coast.nc', icot, ldstop = .FALSE. )
@@ -333,5 +355,5 @@
          zinfl = 1000.e3                   ! distance of influence for damping term
          zlat0 = 10.                       ! latitude strip where resto decreases
-         zlat1 = REAL( nn_hdmp )           ! resto = 0 between -zlat1 and zlat1
+         zlat1 = REAL( kn_hdmp )           ! resto = 0 between -zlat1 and zlat1
          zlat2 = zlat1 + zlat0             ! resto increases from 0 to 1 between |zlat1| and |zlat2|
 
@@ -340,12 +362,12 @@
                zlat = ABS( gphit(ji,jj) )
                IF ( zlat1 <= zlat .AND. zlat <= zlat2 ) THEN
-                  resto(ji,jj,1) = 0.5 * ( 1. - cos(rpi*(zlat-zlat1)/zlat0 ) )
+                  presto(ji,jj,1) = 0.5 * ( 1. - cos(rpi*(zlat-zlat1)/zlat0 ) )
                ELSEIF ( zlat > zlat2 ) THEN
-                  resto(ji,jj,1) = 1.
+                  presto(ji,jj,1) = 1.
                ENDIF
             END DO
          END DO
 
-         IF ( nn_hdmp == 20 ) THEN       ! North Indian ocean (20N/30N x 45E/100E) : resto=0
+         IF ( kn_hdmp == 20 ) THEN       ! North Indian ocean (20N/30N x 45E/100E) : resto=0
             DO jj = 1, jpj
                DO ji = 1, jpi
@@ -353,5 +375,5 @@
                   zlon = MOD( glamt(ji,jj), 360. )
                   IF ( zlat1 < zlat .AND. zlat < zlat2 .AND. 45. < zlon .AND. zlon < 100. ) THEN
-                     resto(ji,jj,1) = 0.e0
+                     presto(ji,jj,1) = 0.e0
                   ENDIF
                END DO
@@ -359,6 +381,6 @@
          ENDIF
 
-         zsdmp = 1./(rn_surf * rday)
-         zbdmp = 1./(rn_bot  * rday)
+         zsdmp = 1./(pn_surf * rday)
+         zbdmp = 1./(pn_bot  * rday)
          DO jk = 2, jpkm1
             DO jj = 1, jpj
@@ -366,7 +388,7 @@
                   zdct(ji,jj,jk) = MIN( zinfl, zdct(ji,jj,jk) )
                   !   ... Decrease the value in the vicinity of the coast
-                  resto(ji,jj,jk) = resto(ji,jj,1) * 0.5 * ( 1. - COS( rpi*zdct(ji,jj,jk)/zinfl) )
+                  presto(ji,jj,jk) = presto(ji,jj,1) * 0.5 * ( 1. - COS( rpi*zdct(ji,jj,jk)/zinfl) )
                   !   ... Vertical variation from zsdmp (sea surface) to zbdmp (bottom)
-                  resto(ji,jj,jk) = resto(ji,jj,jk)      * ( zbdmp + (zsdmp-zbdmp)*EXP(-fsdept(ji,jj,jk)/rn_dep) )
+                  presto(ji,jj,jk) = presto(ji,jj,jk)      * ( zbdmp + (zsdmp-zbdmp)*EXP(-fsdept(ji,jj,jk)/pn_dep) )
                END DO
             END DO
@@ -376,5 +398,5 @@
 
 
-      IF( cp_cfg == "orca" .AND. ( nn_hdmp > 0 .OR. nn_hdmp == -1 ) ) THEN
+      IF( cp_cfg == "orca" .AND. ( kn_hdmp > 0 .OR. kn_hdmp == -1 ) ) THEN
 
          !                                         ! =========================
@@ -465,8 +487,8 @@
                zmrs( ji , mj0(ij0):mj1(ij1) ) = 0.1 * ABS( FLOAT(ji - mi1(ii1)) )
             END DO 
-            zsdmp = 1./(rn_surf * rday)
-            zbdmp = 1./(rn_bot * rday)
+            zsdmp = 1./(pn_surf * rday)
+            zbdmp = 1./(pn_bot  * rday)
             DO jk = 1, jpk
-               zhfac (jk) = ( zbdmp + (zsdmp-zbdmp) * EXP(-fsdept(1,1,jk)/rn_dep) )
+               zhfac (jk) = ( zbdmp + (zsdmp-zbdmp) * EXP(-fsdept(1,1,jk)/pn_dep) )
             END DO
             !                                       ! ========================
@@ -478,11 +500,11 @@
 
          DO jk = 1, jpkm1
-            resto(:,:,jk) = zmrs(:,:) * zhfac(jk) + ( 1. - zmrs(:,:) ) * resto(:,:,jk)
+            presto(:,:,jk) = zmrs(:,:) * zhfac(jk) + ( 1. - zmrs(:,:) ) * presto(:,:,jk)
          END DO
 
          ! Mask resto array and set to 0 first and last levels
-         resto(:,:, : ) = resto(:,:,:) * tmask(:,:,:)
-         resto(:,:, 1 ) = 0.e0
-         resto(:,:,jpk) = 0.e0
+         presto(:,:, : ) = presto(:,:,:) * tmask(:,:,:)
+         presto(:,:, 1 ) = 0.e0
+         presto(:,:,jpk) = 0.e0
          !                         !--------------------!
       ELSE                         !     No damping     !
@@ -492,9 +514,12 @@
 
       !                            !--------------------------------!
-      IF( nn_file == 1 ) THEN      !  save damping coef. in a file  !
+      IF( kn_file == 1 ) THEN      !  save damping coef. in a file  !
          !                         !--------------------------------!
          IF(lwp) WRITE(numout,*) '              create damping.coeff.nc file'
-         CALL iom_open  ( 'damping.coeff', inum0, ldwrt = .TRUE., kiolib = jprstlib )
-         CALL iom_rstput( 0, 0, inum0, 'Resto', resto )
+         IF( cdtype == 'TRA' ) cfile = 'damping.coeff'
+         IF( cdtype == 'TRC' ) cfile = 'damping.coeff.trc'
+         cfile = TRIM( cfile )
+         CALL iom_open  ( cfile, inum0, ldwrt = .TRUE., kiolib = jprstlib )
+         CALL iom_rstput( 0, 0, inum0, 'Resto', presto )
          CALL iom_close ( inum0 )
       ENDIF
